Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 898290 - sci-libs/scalapack-2.2.0_p20240704 fails to compile: igsum2d_.c:153:7: error: call to undeclared function BI_imvcopy; ISO C99 and later do not support implicit function declarations [-Wimplicit-function-declaration]
Summary: sci-libs/scalapack-2.2.0_p20240704 fails to compile: igsum2d_.c:153:7: error:...
Status: CONFIRMED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo Science Related Packages
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: c99-porting
  Show dependency tree
 
Reported: 2023-02-28 09:49 UTC by Agostino Sarubbo
Modified: 2024-07-05 21:52 UTC (History)
3 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
build.log (build.log,87.99 KB, text/plain)
2023-02-28 09:49 UTC, Agostino Sarubbo
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Agostino Sarubbo gentoo-dev 2023-02-28 09:49:42 UTC
https://blogs.gentoo.org/ago/2020/07/04/gentoo-tinderbox/

Issue: sci-libs/scalapack-2.1.0 fails to compile (MUSL-CLANG-SYSTEM).
Discovered on: amd64 (internal ref: tinderbox_musl)

NOTE:
(MUSL-CLANG-SYSTEM) in the summary means that bug was found on a machine that runs MUSL libc + clang16 but this bug MAY or MAY NOT BE related to musl/clang16.
Comment 1 Agostino Sarubbo gentoo-dev 2023-02-28 09:49:45 UTC
Created attachment 855114 [details]
build.log

build log and emerge --info
Comment 2 Agostino Sarubbo gentoo-dev 2023-02-28 09:49:47 UTC
Error(s) that match a know pattern in addition to what has been reported in the summary:


FAILED: CMakeFiles/scalapack.dir/BLACS/SRC/cgsum2d_.c.o 
FAILED: CMakeFiles/scalapack.dir/BLACS/SRC/dgamx2d_.c.o 
FAILED: CMakeFiles/scalapack.dir/BLACS/SRC/dgsum2d_.c.o 
FAILED: CMakeFiles/scalapack.dir/BLACS/SRC/igamx2d_.c.o 
FAILED: CMakeFiles/scalapack.dir/BLACS/SRC/igsum2d_.c.o 
FAILED: CMakeFiles/scalapack.dir/BLACS/SRC/sgamx2d_.c.o 
FAILED: CMakeFiles/scalapack.dir/BLACS/SRC/sgsum2d_.c.o 
FAILED: CMakeFiles/scalapack.dir/BLACS/SRC/zgsum2d_.c.o 
/var/tmp/portage/sci-libs/scalapack-2.1.0/work/scalapack-2.1.0/BLACS/SRC/igsum2d_.c:153:7: error: call to undeclared function 'BI_imvcopy'; ISO C99 and later do not support implicit function declarations [-Wimplicit-function-declaration]
Comment 3 Eli Schwartz gentoo-dev 2024-03-05 20:58:51 UTC
Reproduced with glibc + gcc. ;)
Comment 4 Matthias Maier gentoo-dev 2024-07-04 16:34:22 UTC
Still present in 2.2.0_p20240704.
Comment 5 Eli Schwartz gentoo-dev 2024-07-04 16:37:07 UTC
There has been no activity on the upstream ticket. I wouldn't hold my breath. :(
Comment 6 Matthias Maier gentoo-dev 2024-07-04 16:53:09 UTC
(In reply to Eli Schwartz from comment #5)
> There has been no activity on the upstream ticket. I wouldn't hold my
> breath. :(

Yes, the reference scalapack is a *very* dormant project...


I'll put it on my todo list for a quiet minute to hunt down proper header declarations.
Comment 7 Agostino Sarubbo gentoo-dev 2024-07-05 07:00:43 UTC
ci has reproduced this issue with version 2.2.0_p20240704 - Updating summary.
Comment 8 Tiernan Hubble 2024-07-05 20:17:19 UTC
It needs "-Wno-implicit-function-declaration" in CFLAGS to build with gcc 14.

From arch commit: https://aur.archlinux.org/cgit/aur.git/commit/PKGBUILD?h=scalapack

I built it with "-Wno-implicit-function-declaration" in my CFLAGS and it fixed the issue.
Comment 9 Eli Schwartz gentoo-dev 2024-07-05 21:34:26 UTC
(In reply to Tiernan Hubble from comment #8)
> It needs "-Wno-implicit-function-declaration" in CFLAGS to build with gcc 14.
> 
> From arch commit:
> https://aur.archlinux.org/cgit/aur.git/commit/PKGBUILD?h=scalapack
> 
> I built it with "-Wno-implicit-function-declaration" in my CFLAGS and it
> fixed the issue.

This is fundamentally misunderstanding the purpose of the bug report. We know that flag exists, and we know the value has changed to become a Werror.

This is a bug report about the fact that the source code of scalapack uses implicit function declarations, which is problematic since software should not do so -- it is terrifically dangerous!

It needs to be fixed and that's what we are tracking here. It doesn't need to be silenced. If we just wanted to silence it, we would have done that a year ago.
Comment 10 Tiernan Hubble 2024-07-05 21:52:30 UTC
(In reply to Eli Schwartz from comment #9)
> (In reply to Tiernan Hubble from comment #8)
> > It needs "-Wno-implicit-function-declaration" in CFLAGS to build with gcc 14.
> > 
> > From arch commit:
> > https://aur.archlinux.org/cgit/aur.git/commit/PKGBUILD?h=scalapack
> > 
> > I built it with "-Wno-implicit-function-declaration" in my CFLAGS and it
> > fixed the issue.
> 
> This is fundamentally misunderstanding the purpose of the bug report. We
> know that flag exists, and we know the value has changed to become a Werror.
> 
> This is a bug report about the fact that the source code of scalapack uses
> implicit function declarations, which is problematic since software should
> not do so -- it is terrifically dangerous!
> 
> It needs to be fixed and that's what we are tracking here. It doesn't need
> to be silenced. If we just wanted to silence it, we would have done that a
> year ago.

Ah, sorry - I misunderstood.